Subject: Re: [RFC] Support UTF-8 characters in Git alias names

From: Junio C Hamano <[email-masked]>
Date: Mon, 09 Feb 2026 06:55:51 -0800

"brian m. carlson" <[email-masked]> writes:

> I don't think we have any Unicode normalization code at all in Git,
> though, so if you want a quality implementation, that may be a thing we
> need.

Isn't NKC/NKD a macOS-only issue in practice?  Anything on the
command line "git" potty and "git-blah" built-in commands receive
goes through precompose_argv_prefix() to be normalized on that
platform.

>> Before implementing this, I'd like to hear:
>> 
>> 1. Is this a feature the project would like?
>
> I think this would be useful.  I don't personally plan to use it, but I
> can imagine a lot of other people would, and in general I'm in favour of
> better i18n and l10n support.

I am not fundamentally against this, as long as such an addition
does not introduce unnecessary bugs and ambiguities.  IOW, do not
force me to read bug reports in this area after it is done.

>> 2. Is my implementation approach reasonable?
>> 3. What concerns should be addressed in said design?
>
> As I said, Unicode normalization may be a thing you want to support
> here.  Not having it isn't a complete dealbreaker, but it would prevent
> hard-to-debug breakage.

A buggy normalization implementation would be also a source of
unnecessary bugs.  We cannot have and eat that cake so easily ;-).